rust: prevent dead_code warning
[nbdkit.git] / tests / test-retry-readonly.sh
bloba13d111ff06a1ebb012a9866dbdf29a5d642dfc0
1 #!/usr/bin/env bash
2 # nbdkit
3 # Copyright (C) 2018-2020 Red Hat Inc.
5 # Redistribution and use in source and binary forms, with or without
6 # modification, are permitted provided that the following conditions are
7 # met:
9 # * Redistributions of source code must retain the above copyright
10 # notice, this list of conditions and the following disclaimer.
12 # * Redistributions in binary form must reproduce the above copyright
13 # notice, this list of conditions and the following disclaimer in the
14 # documentation and/or other materials provided with the distribution.
16 # * Neither the name of Red Hat nor the names of its contributors may be
17 # used to endorse or promote products derived from this software without
18 # specific prior written permission.
20 # THIS SOFTWARE IS PROVIDED BY RED HAT AND CONTRIBUTORS ''AS IS'' AND
21 # ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO,
22 # THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A
23 # PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL RED HAT OR
24 # CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
25 # SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
26 # LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF
27 # USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
28 # ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
29 # OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT
30 # OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
31 # SUCH DAMAGE.
33 source ./functions.sh
34 set -e
35 set -x
37 requires_plugin sh
38 requires qemu-io --version
40 files="retry-readonly-count retry-readonly-open-count"
41 rm -f $files
42 cleanup_fn rm -f $files
44 touch retry-readonly-count retry-readonly-open-count
45 start_t=$SECONDS
47 # Create a custom plugin which will test retrying.
48 nbdkit -v -U - \
49 sh - \
50 --filter=retry retry-delay=1 retry-readonly=yes \
51 --run 'qemu-io -f raw -c "w 0 512" -c "w 0 512" $nbd || :' <<'EOF'
52 #!/usr/bin/env bash
53 case "$1" in
54 open)
55 # Count how many times the connection is (re-)opened.
56 read i < retry-readonly-open-count
57 echo $((i+1)) > retry-readonly-open-count
59 can_write) ;;
60 pwrite)
61 # Fail 3 times then succeed - however, force-readonly means we will
62 # never return here after the first failure.
63 read i < retry-readonly-count
64 ((i++))
65 echo $i > retry-readonly-count
66 if [ $i -le 3 ]; then
67 echo "EIO pwrite failed" >&2
68 exit 1
69 else
70 : drop data
74 get_size) echo 512 ;;
75 *) exit 2 ;;
76 esac
77 EOF
79 # In this test we should see 3 failures:
80 # first pwrite FAILS
81 # retry and wait 1 seconds
82 # first pwrite FAILS immediately now that connection is readonly
83 # second pwrite FAILS immediately
85 # The minimum time for the test should be 1 second.
86 end_t=$SECONDS
87 if [ $((end_t - start_t)) -lt 1 ]; then
88 echo "$0: test ran too quickly"
89 exit 1
92 # Check the handle was opened 2 times (first open + one reopen).
93 read open_count < retry-readonly-open-count
94 if [ $open_count -ne 2 ]; then
95 echo "$0: open-count ($open_count) != 2"
96 exit 1